package nianioTest.complib.controls;

import genrap.ui.appLogic.comps.NewRadioButtonGroup;
import genrap.ui.compLib.base.CompsFactory;
import genrap.ui.framework.CompHandle;
import nianio.complib.controls.Buttons;
import nianio.complib.controls.RadioButtonGroupCommand;
import nianio.complib.controls.RadioButtonGroupEvent;
import nianio.complib.controls.RadioButtonState;
import nianio.ids.RadioButtonId;
import ocean.common.ArgProc;
import ocean.common.Err;
import ocean.models.ConstModel;
import ocean.models.Model;
import ocean.models.SimpleModel;

public class RadioButtonGroup {
	private final SimpleModel selectedId;
	private final CompHandle group;
	private final RadioButtonGroupEvent.MMIntf invoker;

	private RadioButtonGroup(String text, Buttons buttons,
			RadioButtonId selectedId, RadioButtonGroupEvent.MMIntf invoker,
			CompsFactory cFactory) {
		this.invoker = invoker;
		this.selectedId = new SimpleModel(selectedId);
		ArgProc selectedSetter = new SelectionChanged();
		Model/*String*/label = new ConstModel(text);
		NewRadioButtonGroup.RadioButton[] newButtons = new NewRadioButtonGroup.RadioButton[buttons.size()];
		for (int i = 0, L = buttons.size(); i < L; i++) {
			RadioButtonState bState = buttons.get(i);
			RadioButtonId buttonId = bState.getId();
			Model/*String*/buttonText = new ConstModel(bState.getText());
			Model/*Boolean*/enabled = new ConstModel(new Boolean(
					bState.getEnabled()));
			newButtons[i] = new NewRadioButtonGroup.RadioButton(buttonId,
					buttonText, enabled, null);
		}
		this.group = NewRadioButtonGroup.create(cFactory, label,
				this.selectedId.getModel(), selectedSetter, newButtons);
	}

	public static RadioButtonGroup create(String label, Buttons buttons,
			RadioButtonId selectedId, RadioButtonGroupEvent.MM invoker,
			CompsFactory cFactory) {
		return new RadioButtonGroup(label, buttons, selectedId,
				RadioButtonGroupEvent.MMConv.asIntf(invoker), cFactory);
	}

	private class SelectionChanged implements ArgProc {
		public void run(Object o) {
			invoker.selected((RadioButtonId) o);
		}
	}

	public CompHandle getHandle() {
		return group;
	}

	public void post(RadioButtonGroupCommand cmd) {
		if (cmd.isSelect()) {
			RadioButtonId id = cmd.asSelect();
			if (!id.equals(selectedId.get()))
				selectedId.set(id);
		} else
			throw Err.errM(cmd);
	}
}
