package nianioTest.complib.windows;

import genrap.ui.framework.CompHandle;
import genrap.ui.framework.ParentComp;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

import nianio.complib.FrameEvent;
import nianio.complib.ShownFrameCommand;
import ocean.common.Err;

public class Frame {
	private final JFrame frame;

	private Frame(String title, CompHandle content,
			final FrameEvent.MMIntf invoker) {
		this.frame = new JFrame(title);
		this.frame.getContentPane()
				.add(content.getComp().icomp.getNativeComp());
		this.frame.pack();
		this.frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		this.frame.addWindowListener(new WindowListener() {

			public void windowActivated(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowClosed(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowClosing(WindowEvent e) {
				invoker.closRequest();
			}

			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub

			}
		});
		frame.setVisible(true);
	}

	public static Frame create(String title, CompHandle content,
			FrameEvent.MMIntf invoker) {
		return new Frame(title, content, invoker);
	}

	public void post(ShownFrameCommand cmd) {
		if (cmd.isClose()) {
			frame.dispose();
		} else
			throw Err.errM(cmd);
	}

	public ParentComp getParentComp() {
		return new ParentComp(frame);
	}
}
