package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import schema.runtime.internal.datatypes.ObjectArray;


/** 
 * <pre>array of AppLogicExtCmd
 * Autogenerated class AppLogicExtCmds
 * </pre>
 */ 
public class AppLogicExtCmds implements ImmObject {
	public static final AppLogicExtCmds EMPTY = new AppLogicExtCmds();

	private final ObjectArray arr;
	
	private AppLogicExtCmds(ObjectArray arr) {
		this.arr = arr;
	}
	
	public AppLogicExtCmds() {
		this(ObjectArray.ZERO);
	}
	
	public boolean eq(AppLogicExtCmds obj) {
		return arr.equals(obj.arr);
	}

	public boolean equals(Object obj) {
		return (obj instanceof AppLogicExtCmds) 
				&& eq((AppLogicExtCmds)obj);
	}
	
	public int size() {
		return arr.size();
	}

	public AppLogicExtCmds add(AppLogicExtCmd elem) {
		SchemaException.ensure(elem != null);
		return new AppLogicExtCmds(arr.add(elem));
	}

	public AppLogicExtCmds put(int i, AppLogicExtCmd elem) {
		SchemaException.ensure(elem != null);
		return new AppLogicExtCmds(arr.put(i, elem));
	}

	public AppLogicExtCmds insert(int pos, AppLogicExtCmd elem) {
		SchemaException.ensure(elem != null);
		return new AppLogicExtCmds(arr.insert(pos, elem));
	}

	public AppLogicExtCmds remove(int index) {
		return new AppLogicExtCmds(arr.remove(index));
	}

	public AppLogicExtCmds move(int oldpos, int newpos) {
		return new AppLogicExtCmds(arr.move(oldpos, newpos));
	}

	public AppLogicExtCmds concat(AppLogicExtCmds obj) {
		AppLogicExtCmds res = this;
		for(int i = 0; i < obj.size(); ++i)
			res = res.add(obj.get(i));
		return res;
	}

	public AppLogicExtCmd get(int ix) {
		AppLogicExtCmd elem = (AppLogicExtCmd) (arr.get(ix));
		return elem;
	}
	
	public int find(AppLogicExtCmd elem) {
		return arr.find(elem);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < size(); i++) {
			sb.append(get(i));
			if (i < size()-1)
				sb.append(", ");
		}
		sb.append("]");
		return sb.toString();
	}

	public int hashCode(){
		return arr.hashCode();
	}

 
}
