package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.genrap.OutputKind;


/** 
 * <pre>Autogenerated class AppState = {
 *		  reportFile  : SelectFileState
 *		  xmlFile  : SelectFileState
 *		  xsdFile  : SelectFileState
 *		  outputFile  : SelectFileState
 *		  outputKind  : OutputKind
 *		  status  : Status
 *		  messageDialogStates  : MsgDialogs
 * }</pre>
 */ 

public class AppState implements ImmObject {
	private static final int TYPE_HASH = 1221389072;
	private int hash = 0;

	final private SelectFileState reportFile;
	final private SelectFileState xmlFile;
	final private SelectFileState xsdFile;
	final private SelectFileState outputFile;
	final private OutputKind outputKind;
	final private Status status;
	final private MsgDialogs messageDialogStates;
			
	private AppState(
		 SelectFileState reportFile
		, SelectFileState xmlFile
		, SelectFileState xsdFile
		, SelectFileState outputFile
		, OutputKind outputKind
		, Status status
		, MsgDialogs messageDialogStates
	) {
		this.reportFile = reportFile;
		this.xmlFile = xmlFile;
		this.xsdFile = xsdFile;
		this.outputFile = outputFile;
		this.outputKind = outputKind;
		this.status = status;
		this.messageDialogStates = messageDialogStates;
	}
	

	/** Creates a struct record with given values
	 * @param reportFile != null (mandatory)
	 * @param xmlFile != null (mandatory)
	 * @param xsdFile != null (mandatory)
	 * @param outputFile != null (mandatory)
	 * @param outputKind != null (mandatory)
	 * @param status != null (mandatory)
	 * @param messageDialogStates != null (mandatory)
	 */
	public static AppState create(
		 SelectFileState reportFile
		, SelectFileState xmlFile
		, SelectFileState xsdFile
		, SelectFileState outputFile
		, OutputKind outputKind
		, Status status
		, MsgDialogs messageDialogStates
	) {
		SchemaException.ensure(reportFile != null);
		SchemaException.ensure(xmlFile != null);
		SchemaException.ensure(xsdFile != null);
		SchemaException.ensure(outputFile != null);
		SchemaException.ensure(outputKind != null);
		SchemaException.ensure(status != null);
		SchemaException.ensure(messageDialogStates != null);

		return new AppState(
			 reportFile
			, xmlFile
			, xsdFile
			, outputFile
			, outputKind
			, status
			, messageDialogStates
		);		
	}


	/* getters */
	
	/** field reportFile, should never return null */
	public SelectFileState getReportFile() {
		return this.reportFile;
	}
	/** field xmlFile, should never return null */
	public SelectFileState getXmlFile() {
		return this.xmlFile;
	}
	/** field xsdFile, should never return null */
	public SelectFileState getXsdFile() {
		return this.xsdFile;
	}
	/** field outputFile, should never return null */
	public SelectFileState getOutputFile() {
		return this.outputFile;
	}
	/** field outputKind, should never return null */
	public OutputKind getOutputKind() {
		return this.outputKind;
	}
	/** field status, should never return null */
	public Status getStatus() {
		return this.status;
	}
	/** field messageDialogStates, should never return null */
	public MsgDialogs getMessageDialogStates() {
		return this.messageDialogStates;
	}

	/* setters */
	
	/** create struct with field reportFile modified, 
	 * (exception when arg==null) */
	public AppState setReportFile(SelectFileState reportFile) {	 
		SchemaException.ensure(reportFile != null);
		return new AppState(
			  reportFile 		
			, this.xmlFile 		
			, this.xsdFile 		
			, this.outputFile 		
			, this.outputKind 		
			, this.status 		
			, this.messageDialogStates 		
		);		
	}
	/** create struct with field xmlFile modified, 
	 * (exception when arg==null) */
	public AppState setXmlFile(SelectFileState xmlFile) {	 
		SchemaException.ensure(xmlFile != null);
		return new AppState(
			  this.reportFile 		
			, xmlFile 		
			, this.xsdFile 		
			, this.outputFile 		
			, this.outputKind 		
			, this.status 		
			, this.messageDialogStates 		
		);		
	}
	/** create struct with field xsdFile modified, 
	 * (exception when arg==null) */
	public AppState setXsdFile(SelectFileState xsdFile) {	 
		SchemaException.ensure(xsdFile != null);
		return new AppState(
			  this.reportFile 		
			, this.xmlFile 		
			, xsdFile 		
			, this.outputFile 		
			, this.outputKind 		
			, this.status 		
			, this.messageDialogStates 		
		);		
	}
	/** create struct with field outputFile modified, 
	 * (exception when arg==null) */
	public AppState setOutputFile(SelectFileState outputFile) {	 
		SchemaException.ensure(outputFile != null);
		return new AppState(
			  this.reportFile 		
			, this.xmlFile 		
			, this.xsdFile 		
			, outputFile 		
			, this.outputKind 		
			, this.status 		
			, this.messageDialogStates 		
		);		
	}
	/** create struct with field outputKind modified, 
	 * (exception when arg==null) */
	public AppState setOutputKind(OutputKind outputKind) {	 
		SchemaException.ensure(outputKind != null);
		return new AppState(
			  this.reportFile 		
			, this.xmlFile 		
			, this.xsdFile 		
			, this.outputFile 		
			, outputKind 		
			, this.status 		
			, this.messageDialogStates 		
		);		
	}
	/** create struct with field status modified, 
	 * (exception when arg==null) */
	public AppState setStatus(Status status) {	 
		SchemaException.ensure(status != null);
		return new AppState(
			  this.reportFile 		
			, this.xmlFile 		
			, this.xsdFile 		
			, this.outputFile 		
			, this.outputKind 		
			, status 		
			, this.messageDialogStates 		
		);		
	}
	/** create struct with field messageDialogStates modified, 
	 * (exception when arg==null) */
	public AppState setMessageDialogStates(MsgDialogs messageDialogStates) {	 
		SchemaException.ensure(messageDialogStates != null);
		return new AppState(
			  this.reportFile 		
			, this.xmlFile 		
			, this.xsdFile 		
			, this.outputFile 		
			, this.outputKind 		
			, this.status 		
			, messageDialogStates 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof AppState) 
			&& this.eq((AppState)obj);
	}
	
	public boolean eq(AppState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqReportFile(this, obj)
			&& eqXmlFile(this, obj)
			&& eqXsdFile(this, obj)
			&& eqOutputFile(this, obj)
			&& eqOutputKind(this, obj)
			&& eqStatus(this, obj)
			&& eqMessageDialogStates(this, obj)
			;
	}

	private static boolean eqReportFile(AppState o1, AppState o2) {
		SelectFileState f1 = o1.getReportFile();
		SelectFileState f2 = o2.getReportFile();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqXmlFile(AppState o1, AppState o2) {
		SelectFileState f1 = o1.getXmlFile();
		SelectFileState f2 = o2.getXmlFile();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqXsdFile(AppState o1, AppState o2) {
		SelectFileState f1 = o1.getXsdFile();
		SelectFileState f2 = o2.getXsdFile();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqOutputFile(AppState o1, AppState o2) {
		SelectFileState f1 = o1.getOutputFile();
		SelectFileState f2 = o2.getOutputFile();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqOutputKind(AppState o1, AppState o2) {
		OutputKind f1 = o1.getOutputKind();
		OutputKind f2 = o2.getOutputKind();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqStatus(AppState o1, AppState o2) {
		Status f1 = o1.getStatus();
		Status f2 = o2.getStatus();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqMessageDialogStates(AppState o1, AppState o2) {
		MsgDialogs f1 = o1.getMessageDialogStates();
		MsgDialogs f2 = o2.getMessageDialogStates();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("reportFile" + "=");
		out.append(getReportFile());
		out.append(", ");
		out.append("xmlFile" + "=");
		out.append(getXmlFile());
		out.append(", ");
		out.append("xsdFile" + "=");
		out.append(getXsdFile());
		out.append(", ");
		out.append("outputFile" + "=");
		out.append(getOutputFile());
		out.append(", ");
		out.append("outputKind" + "=");
		out.append(getOutputKind());
		out.append(", ");
		out.append("status" + "=");
		out.append(getStatus());
		out.append(", ");
		out.append("messageDialogStates" + "=");
		out.append(getMessageDialogStates());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.reportFile.hashCode() + -163502560;
			h ^= this.xmlFile.hashCode() + -54905117;
			h ^= this.xsdFile.hashCode() + 109481621;
			h ^= this.outputFile.hashCode() + 926235501;
			h ^= this.outputKind.hashCode() + 926384517;
			h ^= this.status.hashCode() + 2078021954;
			h ^= this.messageDialogStates.hashCode() + -1599702079;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}