package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import schema.runtime.internal.datatypes.ObjectArray;


/** 
 * <pre>array of ExternalCommand
 * Autogenerated class ExternalCommands
 * </pre>
 */ 
public class ExternalCommands implements ImmObject {
	public static final ExternalCommands EMPTY = new ExternalCommands();

	private final ObjectArray arr;
	
	private ExternalCommands(ObjectArray arr) {
		this.arr = arr;
	}
	
	public ExternalCommands() {
		this(ObjectArray.ZERO);
	}
	
	public boolean eq(ExternalCommands obj) {
		return arr.equals(obj.arr);
	}

	public boolean equals(Object obj) {
		return (obj instanceof ExternalCommands) 
				&& eq((ExternalCommands)obj);
	}
	
	public int size() {
		return arr.size();
	}

	public ExternalCommands add(ExternalCommand elem) {
		SchemaException.ensure(elem != null);
		return new ExternalCommands(arr.add(elem));
	}

	public ExternalCommands put(int i, ExternalCommand elem) {
		SchemaException.ensure(elem != null);
		return new ExternalCommands(arr.put(i, elem));
	}

	public ExternalCommands insert(int pos, ExternalCommand elem) {
		SchemaException.ensure(elem != null);
		return new ExternalCommands(arr.insert(pos, elem));
	}

	public ExternalCommands remove(int index) {
		return new ExternalCommands(arr.remove(index));
	}

	public ExternalCommands move(int oldpos, int newpos) {
		return new ExternalCommands(arr.move(oldpos, newpos));
	}

	public ExternalCommands concat(ExternalCommands obj) {
		ExternalCommands res = this;
		for(int i = 0; i < obj.size(); ++i)
			res = res.add(obj.get(i));
		return res;
	}

	public ExternalCommand get(int ix) {
		ExternalCommand elem = (ExternalCommand) (arr.get(ix));
		return elem;
	}
	
	public int find(ExternalCommand elem) {
		return arr.find(elem);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < size(); i++) {
			sb.append(get(i));
			if (i < size()-1)
				sb.append(", ");
		}
		sb.append("]");
		return sb.toString();
	}

	public int hashCode(){
		return arr.hashCode();
	}

 
}
