package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.internal.datatypes.ObjectRecord;
import java.util.Iterator;
import schema.runtime.err.SchemaException;


/** 
 * <pre>dictionary of Entry
 * Autogenerated class MsgDialogs</pre>
 */ 
public class MsgDialogs implements ImmObject {
	public static final MsgDialogs EMPTY = new MsgDialogs();
	private static final int TYPE_HASH = -1504954998;

	private final ObjectRecord map;
	private int hash = 0;

	private MsgDialogs(ObjectRecord map) {
		this.map = map;
	}
	
	private MsgDialogs() {
		this(ObjectRecord.ZERO);
	}

	static public final MsgDialogs create() {
		return EMPTY;
	}
	
	public boolean eq(MsgDialogs obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;	
		if (map.size() != obj.map.size())
			return false;
		for (Iterator it = map.iterator(); it.hasNext();) {
			Object value = ((ObjectRecord.Entry) it.next()).value;
			Entry e1 = castElem(value);
			Entry e2 = obj.tryGet(getKey(e1));
			if (e2 == null)
				return false;
			if (!eqElem(e1, e2))
				return false;
		}
		return true;
	}
	private static boolean eqElem(Entry o1, Entry o2) {
		return o1==null ? (o2==null) : (o2!=null && o1.eq(o2));
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof MsgDialogs) 
			&& this.eq((MsgDialogs)obj);
	}
	
	public boolean hasKey(String key) {
		return map.hasField(key);
	}
	
	private static Entry castElem(Object obj) {
		Entry elem = (Entry) obj;
		return elem;
	}
	
	public Entry tryGet(String key) {
		return (Entry)(map.get(key));
	}

	/** returns an array by transfer */
	public Entry[] getAll() {
		Entry[] res = new Entry[map.size()];
		int ix = 0;
		for (Iterator it = map.iterator(); it.hasNext();) {
			Object value = ((ObjectRecord.Entry) it.next()).value;
			res[ix++] = castElem(value);
		}
		return res;
	}

	public int size() {
		return map.size();
	}
	
	public MsgDialogs put(Entry elem) {
		SchemaException.ensure(elem != null && getKey(elem) != null);
		return new MsgDialogs(map.put(getKey(elem), elem));
	}	
	
	private String getKey(Entry elem) {
		return elem.getKey();
	}
	
	public MsgDialogs remove(String key) {
		SchemaException.ensure(key != null);
		return new MsgDialogs(map.removeKey(key));
	}

	public String toString() {
		Entry[] data = getAll();
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < data.length; i++) {
			sb.append(data[i]);
			if (i < size()-1)
				sb.append(", ");
		}
		sb.append("]");
		return sb.toString();
	}

	public int hashCode(){
		if (hash == 0){
			int h = hash;
			for (Iterator it = map.iterator(); it.hasNext();) {
				Object value = ((ObjectRecord.Entry) it.next()).value;
				h ^= value.hashCode();
			}
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}