package nianio;

import schema.runtime.datatypes.ImmObject;
import nianio.complib.filechooser.FileChooserResult;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class SelectFileCmd = variant {
 *	    setFileName of String  
 *	 |  selectFromFileChooser 
 *	 |  fileSelected of FileChooserResult  
 * }</pre>
 */ 
public class SelectFileCmd implements ImmObject {
	private static final int TYPE_HASH = 667390306;
	private int hash = 0;

	private static final SelectFileCmd CONST_SELECTFROMFILECHOOSER = new SelectFileCmd(1);
	private final int variant;
	private final Object value;  

	private SelectFileCmd(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private SelectFileCmd(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static SelectFileCmd createSetFileName(String value) {
		return new SelectFileCmd(0, value);
	}

	public static SelectFileCmd createSelectFromFileChooser() {
		return CONST_SELECTFROMFILECHOOSER;
	}

	public static SelectFileCmd createFileSelected(FileChooserResult value) {
		return new SelectFileCmd(2, value);
	}



	/** @return true, when this is setFileName */
	public boolean isSetFileName() {
		return variant == 0;
	}

	/** @return variant value, when this is setFileName; throws Exception otherwise */
	public String asSetFileName() {
		SchemaException.ensure(isSetFileName());
		return ((String)value);
	}

	/** @return true, when this is selectFromFileChooser */
	public boolean isSelectFromFileChooser() {
		return variant == 1;
	}


	/** @return true, when this is fileSelected */
	public boolean isFileSelected() {
		return variant == 2;
	}

	/** @return variant value, when this is fileSelected; throws Exception otherwise */
	public FileChooserResult asFileSelected() {
		SchemaException.ensure(isFileSelected());
		return (FileChooserResult)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isSetFileName()) {
			;
		} else if (isSelectFromFileChooser()) {
			;
		} else if (isFileSelected()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isSetFileName()) {
			asSetFileName();
		} else if (isSelectFromFileChooser()) {
			;
		} else if (isFileSelected()) {
			asFileSelected();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isSetFileName())
			return "setFileName" + "(" + asSetFileName() + ")";
		if (isSelectFromFileChooser())
			return "selectFromFileChooser";		
		if (isFileSelected())
			return "fileSelected" + "(" + asFileSelected() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(SelectFileCmd obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof SelectFileCmd) 
			&& this.eq((SelectFileCmd)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for SelectFileCmd
	 */
	public static interface MM {
		public void invoke(SelectFileCmd cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for SelectFileCmd
	 */
	public static interface MMIntf {
		public void setFileName(String value);
		public void selectFromFileChooser();
		public void fileSelected(FileChooserResult value);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for SelectFileCmd
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(SelectFileCmd cmd) {
				 if (cmd.isSetFileName()) {
					mm.setFileName(cmd.asSetFileName());
				} else if (cmd.isSelectFromFileChooser()) {
					mm.selectFromFileChooser();
				} else if (cmd.isFileSelected()) {
					mm.fileSelected(cmd.asFileSelected());
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void setFileName(String value) {
				mm.invoke(SelectFileCmd.createSetFileName(value));
			}
		
			public void selectFromFileChooser() {
				mm.invoke(SelectFileCmd.createSelectFromFileChooser());
			}
		
			public void fileSelected(FileChooserResult value) {
				mm.invoke(SelectFileCmd.createFileSelected(value));
			}
		
		}
	}
}