package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.UserDialogId;
import schema.runtime.err.SchemaException;
import nianio.ids.WindowId;


/** 
 * <pre>Autogenerated class DialogState = {
 *		  id  : UserDialogId
 *		  parentId  : WindowId
 *		  title  : String
 *		  isModal  : boolean
 *		  isResizable  : boolean
 *		  content  : CompState
 * }</pre>
 */ 

public class DialogState implements ImmObject {
	private static final int TYPE_HASH = 1680509961;
	private int hash = 0;

	final private UserDialogId id;
	final private WindowId parentId;
	final private String title;
	final private boolean isModal;
	final private boolean isResizable;
	final private CompState content;
			
	private DialogState(
		 UserDialogId id
		, WindowId parentId
		, String title
		, boolean isModal
		, boolean isResizable
		, CompState content
	) {
		this.id = id;
		this.parentId = parentId;
		this.title = title;
		this.isModal = isModal;
		this.isResizable = isResizable;
		this.content = content;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param parentId != null (mandatory)
	 * @param title != null (mandatory)
	 * @param isModal != null (mandatory)
	 * @param isResizable != null (mandatory)
	 * @param content != null (mandatory)
	 */
	public static DialogState create(
		 UserDialogId id
		, WindowId parentId
		, String title
		, boolean isModal
		, boolean isResizable
		, CompState content
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(parentId != null);
		SchemaException.ensure(title != null);
		SchemaException.ensure(true);
		SchemaException.ensure(true);
		SchemaException.ensure(content != null);

		return new DialogState(
			 id
			, parentId
			, title
			, isModal
			, isResizable
			, content
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public UserDialogId getId() {
		return this.id;
	}
	/** field parentId, should never return null */
	public WindowId getParentId() {
		return this.parentId;
	}
	/** field title, should never return null */
	public String getTitle() {
		return this.title;
	}
	/** field isModal, should never return null */
	public boolean getIsModal() {
		return this.isModal;
	}
	/** field isResizable, should never return null */
	public boolean getIsResizable() {
		return this.isResizable;
	}
	/** field content, should never return null */
	public CompState getContent() {
		return this.content;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public DialogState setId(UserDialogId id) {	 
		SchemaException.ensure(id != null);
		return new DialogState(
			  id 		
			, this.parentId 		
			, this.title 		
			, this.isModal 		
			, this.isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field parentId modified, 
	 * (exception when arg==null) */
	public DialogState setParentId(WindowId parentId) {	 
		SchemaException.ensure(parentId != null);
		return new DialogState(
			  this.id 		
			, parentId 		
			, this.title 		
			, this.isModal 		
			, this.isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field title modified, 
	 * (exception when arg==null) */
	public DialogState setTitle(String title) {	 
		SchemaException.ensure(title != null);
		return new DialogState(
			  this.id 		
			, this.parentId 		
			, title 		
			, this.isModal 		
			, this.isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field isModal modified, 
	 * (exception when arg==null) */
	public DialogState setIsModal(boolean isModal) {	 
		SchemaException.ensure(true);
		return new DialogState(
			  this.id 		
			, this.parentId 		
			, this.title 		
			, isModal 		
			, this.isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field isResizable modified, 
	 * (exception when arg==null) */
	public DialogState setIsResizable(boolean isResizable) {	 
		SchemaException.ensure(true);
		return new DialogState(
			  this.id 		
			, this.parentId 		
			, this.title 		
			, this.isModal 		
			, isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field content modified, 
	 * (exception when arg==null) */
	public DialogState setContent(CompState content) {	 
		SchemaException.ensure(content != null);
		return new DialogState(
			  this.id 		
			, this.parentId 		
			, this.title 		
			, this.isModal 		
			, this.isResizable 		
			, content 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof DialogState) 
			&& this.eq((DialogState)obj);
	}
	
	public boolean eq(DialogState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqParentId(this, obj)
			&& eqTitle(this, obj)
			&& eqIsModal(this, obj)
			&& eqIsResizable(this, obj)
			&& eqContent(this, obj)
			;
	}

	private static boolean eqId(DialogState o1, DialogState o2) {
		UserDialogId f1 = o1.getId();
		UserDialogId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqParentId(DialogState o1, DialogState o2) {
		WindowId f1 = o1.getParentId();
		WindowId f2 = o2.getParentId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqTitle(DialogState o1, DialogState o2) {
		String f1 = o1.getTitle();
		String f2 = o2.getTitle();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqIsModal(DialogState o1, DialogState o2) {
		boolean f1 = o1.getIsModal();
		boolean f2 = o2.getIsModal();
		return 	f1 == f2;
	}
	private static boolean eqIsResizable(DialogState o1, DialogState o2) {
		boolean f1 = o1.getIsResizable();
		boolean f2 = o2.getIsResizable();
		return 	f1 == f2;
	}
	private static boolean eqContent(DialogState o1, DialogState o2) {
		CompState f1 = o1.getContent();
		CompState f2 = o2.getContent();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("parentId" + "=");
		out.append(getParentId());
		out.append(", ");
		out.append("title" + "=");
		out.append(getTitle());
		out.append(", ");
		out.append("isModal" + "=");
		out.append(getIsModal());
		out.append(", ");
		out.append("isResizable" + "=");
		out.append(getIsResizable());
		out.append(", ");
		out.append("content" + "=");
		out.append(getContent());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.parentId.hashCode() + -324221771;
			h ^= this.title.hashCode() + -1594921208;
			h ^= this.isModal ? -338196397 : 338196396;
			h ^= this.isResizable ? -1475957423 : 1475957422;
			h ^= this.content.hashCode() + -1452141271;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}