package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.FileChooserId;
import nianio.complib.filechooser.FileChooserEvent;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class FileChooserIdEvent = {
 *		  id  : FileChooserId
 *		  event  : FileChooserEvent
 * }</pre>
 */ 

public class FileChooserIdEvent implements ImmObject {
	private static final int TYPE_HASH = -1665948352;
	private int hash = 0;

	final private FileChooserId id;
	final private FileChooserEvent event;
			
	private FileChooserIdEvent(
		 FileChooserId id
		, FileChooserEvent event
	) {
		this.id = id;
		this.event = event;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param event != null (mandatory)
	 */
	public static FileChooserIdEvent create(
		 FileChooserId id
		, FileChooserEvent event
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(event != null);

		return new FileChooserIdEvent(
			 id
			, event
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public FileChooserId getId() {
		return this.id;
	}
	/** field event, should never return null */
	public FileChooserEvent getEvent() {
		return this.event;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public FileChooserIdEvent setId(FileChooserId id) {	 
		SchemaException.ensure(id != null);
		return new FileChooserIdEvent(
			  id 		
			, this.event 		
		);		
	}
	/** create struct with field event modified, 
	 * (exception when arg==null) */
	public FileChooserIdEvent setEvent(FileChooserEvent event) {	 
		SchemaException.ensure(event != null);
		return new FileChooserIdEvent(
			  this.id 		
			, event 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof FileChooserIdEvent) 
			&& this.eq((FileChooserIdEvent)obj);
	}
	
	public boolean eq(FileChooserIdEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqEvent(this, obj)
			;
	}

	private static boolean eqId(FileChooserIdEvent o1, FileChooserIdEvent o2) {
		FileChooserId f1 = o1.getId();
		FileChooserId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqEvent(FileChooserIdEvent o1, FileChooserIdEvent o2) {
		FileChooserEvent f1 = o1.getEvent();
		FileChooserEvent f2 = o2.getEvent();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("event" + "=");
		out.append(getEvent());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.event.hashCode() + -1608401078;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}