package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.complib.messagedialog.MessageDialogEvent;
import nianio.ids.MessageDialogId;


/** 
 * <pre>Autogenerated class MessageDialogIdEvent = {
 *		  id  : MessageDialogId
 *		  event  : MessageDialogEvent
 * }</pre>
 */ 

public class MessageDialogIdEvent implements ImmObject {
	private static final int TYPE_HASH = -340988112;
	private int hash = 0;

	final private MessageDialogId id;
	final private MessageDialogEvent event;
			
	private MessageDialogIdEvent(
		 MessageDialogId id
		, MessageDialogEvent event
	) {
		this.id = id;
		this.event = event;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param event != null (mandatory)
	 */
	public static MessageDialogIdEvent create(
		 MessageDialogId id
		, MessageDialogEvent event
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(event != null);

		return new MessageDialogIdEvent(
			 id
			, event
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public MessageDialogId getId() {
		return this.id;
	}
	/** field event, should never return null */
	public MessageDialogEvent getEvent() {
		return this.event;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public MessageDialogIdEvent setId(MessageDialogId id) {	 
		SchemaException.ensure(id != null);
		return new MessageDialogIdEvent(
			  id 		
			, this.event 		
		);		
	}
	/** create struct with field event modified, 
	 * (exception when arg==null) */
	public MessageDialogIdEvent setEvent(MessageDialogEvent event) {	 
		SchemaException.ensure(event != null);
		return new MessageDialogIdEvent(
			  this.id 		
			, event 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof MessageDialogIdEvent) 
			&& this.eq((MessageDialogIdEvent)obj);
	}
	
	public boolean eq(MessageDialogIdEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqEvent(this, obj)
			;
	}

	private static boolean eqId(MessageDialogIdEvent o1, MessageDialogIdEvent o2) {
		MessageDialogId f1 = o1.getId();
		MessageDialogId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqEvent(MessageDialogIdEvent o1, MessageDialogIdEvent o2) {
		MessageDialogEvent f1 = o1.getEvent();
		MessageDialogEvent f2 = o2.getEvent();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("event" + "=");
		out.append(getEvent());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.event.hashCode() + -1608401078;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}