package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class UserDialogEvent =
 * variant (enumeration) {
 *	    closing 
 * }
 */ 
public class UserDialogEvent implements ImmObject {
	private static final int TYPE_HASH = 917457223;


	private static final UserDialogEvent CONST_CLOSING = new UserDialogEvent(0);

	private final int variant;

	private UserDialogEvent(int variant) {
		this.variant = variant;
	}


	public static UserDialogEvent createClosing() {
		return CONST_CLOSING;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isClosing()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is closing */
	public boolean isClosing() {
		return variant == 0;
	}




	public String toString() {
		if (isClosing())
			return "closing";
		throw SchemaException.err();
	}
	
	public boolean eq(UserDialogEvent obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof UserDialogEvent) 
			&& this.eq((UserDialogEvent)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for UserDialogEvent
	 */
	public static interface MM {
		public void invoke(UserDialogEvent cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for UserDialogEvent
	 */
	public static interface MMIntf {
		public void closing();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for UserDialogEvent
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(UserDialogEvent cmd) {
				 if (cmd.isClosing()) {
					mm.closing();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void closing() {
				mm.invoke(UserDialogEvent.createClosing());
			}
		
		}
	}
}