package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.ButtonId;


/** 
 * <pre>Autogenerated class ButtonState = {
 *		  id  : ButtonId
 *		  text  : String
 *		  enabled  : boolean
 * }</pre>
 */ 

public class ButtonState implements ImmObject {
	private static final int TYPE_HASH = -102628257;
	private int hash = 0;

	final private ButtonId id;
	final private String text;
	final private boolean enabled;
			
	private ButtonState(
		 ButtonId id
		, String text
		, boolean enabled
	) {
		this.id = id;
		this.text = text;
		this.enabled = enabled;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param text != null (mandatory)
	 * @param enabled != null (mandatory)
	 */
	public static ButtonState create(
		 ButtonId id
		, String text
		, boolean enabled
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(text != null);
		SchemaException.ensure(true);

		return new ButtonState(
			 id
			, text
			, enabled
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public ButtonId getId() {
		return this.id;
	}
	/** field text, should never return null */
	public String getText() {
		return this.text;
	}
	/** field enabled, should never return null */
	public boolean getEnabled() {
		return this.enabled;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public ButtonState setId(ButtonId id) {	 
		SchemaException.ensure(id != null);
		return new ButtonState(
			  id 		
			, this.text 		
			, this.enabled 		
		);		
	}
	/** create struct with field text modified, 
	 * (exception when arg==null) */
	public ButtonState setText(String text) {	 
		SchemaException.ensure(text != null);
		return new ButtonState(
			  this.id 		
			, text 		
			, this.enabled 		
		);		
	}
	/** create struct with field enabled modified, 
	 * (exception when arg==null) */
	public ButtonState setEnabled(boolean enabled) {	 
		SchemaException.ensure(true);
		return new ButtonState(
			  this.id 		
			, this.text 		
			, enabled 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof ButtonState) 
			&& this.eq((ButtonState)obj);
	}
	
	public boolean eq(ButtonState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqText(this, obj)
			&& eqEnabled(this, obj)
			;
	}

	private static boolean eqId(ButtonState o1, ButtonState o2) {
		ButtonId f1 = o1.getId();
		ButtonId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqText(ButtonState o1, ButtonState o2) {
		String f1 = o1.getText();
		String f2 = o2.getText();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqEnabled(ButtonState o1, ButtonState o2) {
		boolean f1 = o1.getEnabled();
		boolean f2 = o2.getEnabled();
		return 	f1 == f2;
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("text" + "=");
		out.append(getText());
		out.append(", ");
		out.append("enabled" + "=");
		out.append(getEnabled());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.text.hashCode() + -605642115;
			h ^= this.enabled ? 281701361 : -281701362;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}