package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.RadioButtonId;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class RadioButtonGroupEvent = variant {
 *	    selected of RadioButtonId  
 * }</pre>
 */ 
public class RadioButtonGroupEvent implements ImmObject {
	private static final int TYPE_HASH = 1950237224;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private RadioButtonGroupEvent(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static RadioButtonGroupEvent createSelected(RadioButtonId value) {
		return new RadioButtonGroupEvent(0, value);
	}



	/** @return true, when this is selected */
	public boolean isSelected() {
		return variant == 0;
	}

	/** @return variant value, when this is selected; throws Exception otherwise */
	public RadioButtonId asSelected() {
		SchemaException.ensure(isSelected());
		return (RadioButtonId)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isSelected()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isSelected()) {
			asSelected();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isSelected())
			return "selected" + "(" + asSelected() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(RadioButtonGroupEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonGroupEvent) 
			&& this.eq((RadioButtonGroupEvent)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for RadioButtonGroupEvent
	 */
	public static interface MM {
		public void invoke(RadioButtonGroupEvent cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for RadioButtonGroupEvent
	 */
	public static interface MMIntf {
		public void selected(RadioButtonId value);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for RadioButtonGroupEvent
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(RadioButtonGroupEvent cmd) {
				 if (cmd.isSelected()) {
					mm.selected(cmd.asSelected());
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void selected(RadioButtonId value) {
				mm.invoke(RadioButtonGroupEvent.createSelected(value));
			}
		
		}
	}
}