package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.RadioButtonId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class RadioButtonState = {
 *		  id  : RadioButtonId
 *		  text  : String
 *		  enabled  : boolean
 * }</pre>
 */ 

public class RadioButtonState implements ImmObject {
	private static final int TYPE_HASH = -1423607388;
	private int hash = 0;

	final private RadioButtonId id;
	final private String text;
	final private boolean enabled;
			
	private RadioButtonState(
		 RadioButtonId id
		, String text
		, boolean enabled
	) {
		this.id = id;
		this.text = text;
		this.enabled = enabled;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param text != null (mandatory)
	 * @param enabled != null (mandatory)
	 */
	public static RadioButtonState create(
		 RadioButtonId id
		, String text
		, boolean enabled
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(text != null);
		SchemaException.ensure(true);

		return new RadioButtonState(
			 id
			, text
			, enabled
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public RadioButtonId getId() {
		return this.id;
	}
	/** field text, should never return null */
	public String getText() {
		return this.text;
	}
	/** field enabled, should never return null */
	public boolean getEnabled() {
		return this.enabled;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public RadioButtonState setId(RadioButtonId id) {	 
		SchemaException.ensure(id != null);
		return new RadioButtonState(
			  id 		
			, this.text 		
			, this.enabled 		
		);		
	}
	/** create struct with field text modified, 
	 * (exception when arg==null) */
	public RadioButtonState setText(String text) {	 
		SchemaException.ensure(text != null);
		return new RadioButtonState(
			  this.id 		
			, text 		
			, this.enabled 		
		);		
	}
	/** create struct with field enabled modified, 
	 * (exception when arg==null) */
	public RadioButtonState setEnabled(boolean enabled) {	 
		SchemaException.ensure(true);
		return new RadioButtonState(
			  this.id 		
			, this.text 		
			, enabled 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonState) 
			&& this.eq((RadioButtonState)obj);
	}
	
	public boolean eq(RadioButtonState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqText(this, obj)
			&& eqEnabled(this, obj)
			;
	}

	private static boolean eqId(RadioButtonState o1, RadioButtonState o2) {
		RadioButtonId f1 = o1.getId();
		RadioButtonId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqText(RadioButtonState o1, RadioButtonState o2) {
		String f1 = o1.getText();
		String f2 = o2.getText();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqEnabled(RadioButtonState o1, RadioButtonState o2) {
		boolean f1 = o1.getEnabled();
		boolean f2 = o2.getEnabled();
		return 	f1 == f2;
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("text" + "=");
		out.append(getText());
		out.append(", ");
		out.append("enabled" + "=");
		out.append(getEnabled());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.text.hashCode() + -605642115;
			h ^= this.enabled ? 281701361 : -281701362;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}