package nianio.complib.filechooser;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.FileChooserId;
import schema.runtime.err.SchemaException;
import nianio.ids.WindowId;


/** 
 * <pre>Autogenerated class FileChooserIdParams = {
 *		  id  : FileChooserId
 *		  parentId  : WindowId
 *		  params  : FileChooserParams
 * }</pre>
 */ 

public class FileChooserIdParams implements ImmObject {
	private static final int TYPE_HASH = 191110048;
	private int hash = 0;

	final private FileChooserId id;
	final private WindowId parentId;
	final private FileChooserParams params;
			
	private FileChooserIdParams(
		 FileChooserId id
		, WindowId parentId
		, FileChooserParams params
	) {
		this.id = id;
		this.parentId = parentId;
		this.params = params;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param parentId != null (mandatory)
	 * @param params != null (mandatory)
	 */
	public static FileChooserIdParams create(
		 FileChooserId id
		, WindowId parentId
		, FileChooserParams params
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(parentId != null);
		SchemaException.ensure(params != null);

		return new FileChooserIdParams(
			 id
			, parentId
			, params
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public FileChooserId getId() {
		return this.id;
	}
	/** field parentId, should never return null */
	public WindowId getParentId() {
		return this.parentId;
	}
	/** field params, should never return null */
	public FileChooserParams getParams() {
		return this.params;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public FileChooserIdParams setId(FileChooserId id) {	 
		SchemaException.ensure(id != null);
		return new FileChooserIdParams(
			  id 		
			, this.parentId 		
			, this.params 		
		);		
	}
	/** create struct with field parentId modified, 
	 * (exception when arg==null) */
	public FileChooserIdParams setParentId(WindowId parentId) {	 
		SchemaException.ensure(parentId != null);
		return new FileChooserIdParams(
			  this.id 		
			, parentId 		
			, this.params 		
		);		
	}
	/** create struct with field params modified, 
	 * (exception when arg==null) */
	public FileChooserIdParams setParams(FileChooserParams params) {	 
		SchemaException.ensure(params != null);
		return new FileChooserIdParams(
			  this.id 		
			, this.parentId 		
			, params 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof FileChooserIdParams) 
			&& this.eq((FileChooserIdParams)obj);
	}
	
	public boolean eq(FileChooserIdParams obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqParentId(this, obj)
			&& eqParams(this, obj)
			;
	}

	private static boolean eqId(FileChooserIdParams o1, FileChooserIdParams o2) {
		FileChooserId f1 = o1.getId();
		FileChooserId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqParentId(FileChooserIdParams o1, FileChooserIdParams o2) {
		WindowId f1 = o1.getParentId();
		WindowId f2 = o2.getParentId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqParams(FileChooserIdParams o1, FileChooserIdParams o2) {
		FileChooserParams f1 = o1.getParams();
		FileChooserParams f2 = o2.getParams();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("parentId" + "=");
		out.append(getParentId());
		out.append(", ");
		out.append("params" + "=");
		out.append(getParams());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.parentId.hashCode() + -324221771;
			h ^= this.params.hashCode() + 1975075542;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}