package nianio.complib.filechooser;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class FileChooserKind =
 * variant (enumeration) {
 *	    open 
 *	 |  save 
 * }
 */ 
public class FileChooserKind implements ImmObject {
	private static final int TYPE_HASH = -561820621;


	private static final FileChooserKind CONST_OPEN = new FileChooserKind(0);
	private static final FileChooserKind CONST_SAVE = new FileChooserKind(1);

	private final int variant;

	private FileChooserKind(int variant) {
		this.variant = variant;
	}


	public static FileChooserKind createOpen() {
		return CONST_OPEN;
	}
	
	public static FileChooserKind createSave() {
		return CONST_SAVE;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isOpen()) {
			;
		} else if (isSave()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is open */
	public boolean isOpen() {
		return variant == 0;
	}

	/** @return true, when this is save */
	public boolean isSave() {
		return variant == 1;
	}




	public String toString() {
		if (isOpen())
			return "open";
		if (isSave())
			return "save";
		throw SchemaException.err();
	}
	
	public boolean eq(FileChooserKind obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof FileChooserKind) 
			&& this.eq((FileChooserKind)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		
}