package nianio.complib.messagedialog;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.WindowId;
import ocean.common.Err;
import nianio.ids.MessageDialogId;


/** 
 * <pre>Autogenerated class MessageDialogCommand = variant {
 *	    show of MessageDialogIdParams  
 * }</pre>
 */ 
public class MessageDialogCommand implements ImmObject {
	private static final int TYPE_HASH = -1019453380;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private MessageDialogCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static MessageDialogCommand createShow(MessageDialogIdParams value) {
		return new MessageDialogCommand(0, value);
	}


	public static MessageDialogCommand mkShow(
			MessageDialogId id
			, WindowId parentId
			, MessageDialogParams params
	) {
		return createShow( MessageDialogIdParams.create(
							id
							, parentId
							, params
							 ));
	}
	

	/** @return true, when this is show */
	public boolean isShow() {
		return variant == 0;
	}

	/** @return variant value, when this is show; throws Exception otherwise */
	public MessageDialogIdParams asShow() {
		SchemaException.ensure(isShow());
		return (MessageDialogIdParams)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isShow()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isShow()) {
			asShow();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isShow())
			return "show" + "(" + asShow() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(MessageDialogCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof MessageDialogCommand) 
			&& this.eq((MessageDialogCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for MessageDialogCommand
	 */
	public static interface MM {
		public void invoke(MessageDialogCommand cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for MessageDialogCommand
	 */
	public static interface MMIntf {
		public void show(
				 MessageDialogId id
				, WindowId parentId
				, MessageDialogParams params
		);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for MessageDialogCommand
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(MessageDialogCommand cmd) {
				 if (cmd.isShow()) {
					MessageDialogIdParams val = cmd.asShow();
					mm.show(
							 val.getId()
							, val.getParentId()
							, val.getParams()
					);
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void show(
							 MessageDialogId id
							, WindowId parentId
							, MessageDialogParams params
			) {
				mm.invoke( MessageDialogCommand.createShow(
								MessageDialogIdParams.create( 
									id, parentId, params)));		
			}
		
		}
	}
}