package nianio.complib.messagedialog;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;
import nianio.ids.MessageDialogId;


/** 
 * <pre>Autogenerated class MessageDialogEvent = variant {
 *	    closed of MessageDialogId  
 * }</pre>
 */ 
public class MessageDialogEvent implements ImmObject {
	private static final int TYPE_HASH = -1657111605;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private MessageDialogEvent(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static MessageDialogEvent createClosed(MessageDialogId value) {
		return new MessageDialogEvent(0, value);
	}



	/** @return true, when this is closed */
	public boolean isClosed() {
		return variant == 0;
	}

	/** @return variant value, when this is closed; throws Exception otherwise */
	public MessageDialogId asClosed() {
		SchemaException.ensure(isClosed());
		return (MessageDialogId)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isClosed()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isClosed()) {
			asClosed();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isClosed())
			return "closed" + "(" + asClosed() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(MessageDialogEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof MessageDialogEvent) 
			&& this.eq((MessageDialogEvent)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for MessageDialogEvent
	 */
	public static interface MM {
		public void invoke(MessageDialogEvent cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for MessageDialogEvent
	 */
	public static interface MMIntf {
		public void closed(MessageDialogId value);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for MessageDialogEvent
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(MessageDialogEvent cmd) {
				 if (cmd.isClosed()) {
					mm.closed(cmd.asClosed());
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void closed(MessageDialogId value) {
				mm.invoke(MessageDialogEvent.createClosed(value));
			}
		
		}
	}
}