package nianio.genrap;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import schema.runtime.internal.datatypes.ObjectArray;


/** 
 * <pre>array of GenrapPluginCommand
 * Autogenerated class GenrapPluginCommands
 * </pre>
 */ 
public class GenrapPluginCommands implements ImmObject {
	public static final GenrapPluginCommands EMPTY = new GenrapPluginCommands();

	private final ObjectArray arr;
	
	private GenrapPluginCommands(ObjectArray arr) {
		this.arr = arr;
	}
	
	public GenrapPluginCommands() {
		this(ObjectArray.ZERO);
	}
	
	public boolean eq(GenrapPluginCommands obj) {
		return arr.equals(obj.arr);
	}

	public boolean equals(Object obj) {
		return (obj instanceof GenrapPluginCommands) 
				&& eq((GenrapPluginCommands)obj);
	}
	
	public int size() {
		return arr.size();
	}

	public GenrapPluginCommands add(GenrapPluginCommand elem) {
		SchemaException.ensure(elem != null);
		return new GenrapPluginCommands(arr.add(elem));
	}

	public GenrapPluginCommands put(int i, GenrapPluginCommand elem) {
		SchemaException.ensure(elem != null);
		return new GenrapPluginCommands(arr.put(i, elem));
	}

	public GenrapPluginCommands insert(int pos, GenrapPluginCommand elem) {
		SchemaException.ensure(elem != null);
		return new GenrapPluginCommands(arr.insert(pos, elem));
	}

	public GenrapPluginCommands remove(int index) {
		return new GenrapPluginCommands(arr.remove(index));
	}

	public GenrapPluginCommands move(int oldpos, int newpos) {
		return new GenrapPluginCommands(arr.move(oldpos, newpos));
	}

	public GenrapPluginCommands concat(GenrapPluginCommands obj) {
		GenrapPluginCommands res = this;
		for(int i = 0; i < obj.size(); ++i)
			res = res.add(obj.get(i));
		return res;
	}

	public GenrapPluginCommand get(int ix) {
		GenrapPluginCommand elem = (GenrapPluginCommand) (arr.get(ix));
		return elem;
	}
	
	public int find(GenrapPluginCommand elem) {
		return arr.find(elem);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < size(); i++) {
			sb.append(get(i));
			if (i < size()-1)
				sb.append(", ");
		}
		sb.append("]");
		return sb.toString();
	}

	public int hashCode(){
		return arr.hashCode();
	}

 
}
