package nianio.ids;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class ButtonId = variant {
 *	    fileInput of FileInputId  
 *	 |  generate 
 * }</pre>
 */ 
public class ButtonId implements ImmObject {
	private static final int TYPE_HASH = -1043361779;
	private int hash = 0;

	private static final ButtonId CONST_GENERATE = new ButtonId(1);
	private final int variant;
	private final Object value;  

	private ButtonId(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private ButtonId(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static ButtonId createFileInput(FileInputId value) {
		return new ButtonId(0, value);
	}

	public static ButtonId createGenerate() {
		return CONST_GENERATE;
	}



	/** @return true, when this is fileInput */
	public boolean isFileInput() {
		return variant == 0;
	}

	/** @return variant value, when this is fileInput; throws Exception otherwise */
	public FileInputId asFileInput() {
		SchemaException.ensure(isFileInput());
		return (FileInputId)value;
	}

	/** @return true, when this is generate */
	public boolean isGenerate() {
		return variant == 1;
	}




	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isFileInput()) {
			;
		} else if (isGenerate()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isFileInput()) {
			asFileInput();
		} else if (isGenerate()) {
			;
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isFileInput())
			return "fileInput" + "(" + asFileInput() + ")";
		if (isGenerate())
			return "generate";		
		throw SchemaException.err();
	}
	
	public boolean eq(ButtonId obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof ButtonId) 
			&& this.eq((ButtonId)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}