package nianio.ids;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class FileInputId =
 * variant (enumeration) {
 *	    raport 
 *	 |  data 
 *	 |  schema 
 *	 |  output 
 * }
 */ 
public class FileInputId implements ImmObject {
	private static final int TYPE_HASH = 1226505545;


	private static final FileInputId CONST_RAPORT = new FileInputId(0);
	private static final FileInputId CONST_DATA = new FileInputId(1);
	private static final FileInputId CONST_SCHEMA = new FileInputId(2);
	private static final FileInputId CONST_OUTPUT = new FileInputId(3);

	private final int variant;

	private FileInputId(int variant) {
		this.variant = variant;
	}


	public static FileInputId createRaport() {
		return CONST_RAPORT;
	}
	
	public static FileInputId createData() {
		return CONST_DATA;
	}
	
	public static FileInputId createSchema() {
		return CONST_SCHEMA;
	}
	
	public static FileInputId createOutput() {
		return CONST_OUTPUT;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isRaport()) {
			;
		} else if (isData()) {
			;
		} else if (isSchema()) {
			;
		} else if (isOutput()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is raport */
	public boolean isRaport() {
		return variant == 0;
	}

	/** @return true, when this is data */
	public boolean isData() {
		return variant == 1;
	}

	/** @return true, when this is schema */
	public boolean isSchema() {
		return variant == 2;
	}

	/** @return true, when this is output */
	public boolean isOutput() {
		return variant == 3;
	}




	public String toString() {
		if (isRaport())
			return "raport";
		if (isData())
			return "data";
		if (isSchema())
			return "schema";
		if (isOutput())
			return "output";
		throw SchemaException.err();
	}
	
	public boolean eq(FileInputId obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof FileInputId) 
			&& this.eq((FileInputId)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		
}