package nianio.ids;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class Id = variant {
 *	    appUIId of AppUIId  
 * }</pre>
 */ 
public class Id implements ImmObject {
	private static final int TYPE_HASH = 2363;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private Id(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static Id createAppUIId(AppUIId value) {
		return new Id(0, value);
	}



	/** @return true, when this is appUIId */
	public boolean isAppUIId() {
		return variant == 0;
	}

	/** @return variant value, when this is appUIId; throws Exception otherwise */
	public AppUIId asAppUIId() {
		SchemaException.ensure(isAppUIId());
		return (AppUIId)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isAppUIId()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isAppUIId()) {
			asAppUIId();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isAppUIId())
			return "appUIId" + "(" + asAppUIId() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(Id obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof Id) 
			&& this.eq((Id)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}