package nianio.ids;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class LabelId = variant {
 *	    status 
 *	 |  fileInput of FileInputId  
 * }</pre>
 */ 
public class LabelId implements ImmObject {
	private static final int TYPE_HASH = 1601450767;
	private int hash = 0;

	private static final LabelId CONST_STATUS = new LabelId(0);
	private final int variant;
	private final Object value;  

	private LabelId(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private LabelId(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static LabelId createStatus() {
		return CONST_STATUS;
	}

	public static LabelId createFileInput(FileInputId value) {
		return new LabelId(1, value);
	}



	/** @return true, when this is status */
	public boolean isStatus() {
		return variant == 0;
	}


	/** @return true, when this is fileInput */
	public boolean isFileInput() {
		return variant == 1;
	}

	/** @return variant value, when this is fileInput; throws Exception otherwise */
	public FileInputId asFileInput() {
		SchemaException.ensure(isFileInput());
		return (FileInputId)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isStatus()) {
			;
		} else if (isFileInput()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isStatus()) {
			;
		} else if (isFileInput()) {
			asFileInput();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isStatus())
			return "status";		
		if (isFileInput())
			return "fileInput" + "(" + asFileInput() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(LabelId obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof LabelId) 
			&& this.eq((LabelId)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}