package nianio.ids;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class RadioButtonId =
 * variant (enumeration) {
 *	    pdfOutput 
 *	 |  htmlOutput 
 *	 |  xlsOutput 
 * }
 */ 
public class RadioButtonId implements ImmObject {
	private static final int TYPE_HASH = -1221023512;


	private static final RadioButtonId CONST_PDFOUTPUT = new RadioButtonId(0);
	private static final RadioButtonId CONST_HTMLOUTPUT = new RadioButtonId(1);
	private static final RadioButtonId CONST_XLSOUTPUT = new RadioButtonId(2);

	private final int variant;

	private RadioButtonId(int variant) {
		this.variant = variant;
	}


	public static RadioButtonId createPdfOutput() {
		return CONST_PDFOUTPUT;
	}
	
	public static RadioButtonId createHtmlOutput() {
		return CONST_HTMLOUTPUT;
	}
	
	public static RadioButtonId createXlsOutput() {
		return CONST_XLSOUTPUT;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isPdfOutput()) {
			;
		} else if (isHtmlOutput()) {
			;
		} else if (isXlsOutput()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is pdfOutput */
	public boolean isPdfOutput() {
		return variant == 0;
	}

	/** @return true, when this is htmlOutput */
	public boolean isHtmlOutput() {
		return variant == 1;
	}

	/** @return true, when this is xlsOutput */
	public boolean isXlsOutput() {
		return variant == 2;
	}




	public String toString() {
		if (isPdfOutput())
			return "pdfOutput";
		if (isHtmlOutput())
			return "htmlOutput";
		if (isXlsOutput())
			return "xlsOutput";
		throw SchemaException.err();
	}
	
	public boolean eq(RadioButtonId obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonId) 
			&& this.eq((RadioButtonId)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		
}