#!/usr/bin/perl

sub imm_print {
	my ($stream, %x) = @_;
	my $first = 1;
	print $stream "{";
	for my $key (keys %x) {
		if ($first) {
			$first = 0;
		} else {
			print $stream ", ";
		}
		print $stream "'";
		print $stream $key;
		print $stream "'='";
		print $stream $x{$key};
		print $stream "'";
	}
	print $stream "}\n";
}

sub mkerror {
	my ($msg) = @_;
	$result{'type'} = 'error';
	$result{'line'} = '-1';
	$result{'path'} = '';
	$_ = $msg;
	if (/file\s+(.+\.lang)/i) {
		$result{'path'} = "ui/genrap/ui/lang/lang/$1";
	}
	if (/line\s+([0-9]+)/i) {
		$result{'line'} = $1;
	}
	$result{'desc'} = $msg;
	$result{'res'} = '';
	return %result;
}

sub mkempty {
	my ($type) = @_;
	$result{'type'} = $type;
	$result{'line'} = '-1';
	$result{'path'} = '';
	$result{'desc'} = '';
	$result{'res'} = '';
	return %result;
}


sub autoflush {
	my ($stream) = @_;
	select((select($stream), $| = 1)[0]);
}

open $OUT, ">-";
autoflush($OUT);

while(my $line = <>) {
	$res = `../../../scripts/lang/lang.pl`;
	if ($? != 0) {
		%break = mkerror($res);
		imm_print($OUT, %break);
	}
	%break = mkempty('break');
	imm_print($OUT, %break);
}
close $OUT;